/**
 ** bsflite - bs-free AIM client
 **
 ** (C) 2003-2005 by Claudio Leite <leitec at leitec dot org>
 **
 ** NO WARRANTY. Read the file COPYING for more details.
 **/

#include "bsf.h"

extern char     inputbuf[512];
extern struct Conn *conn;
extern struct BuddyList *buddylist;
extern struct Waiting *waiting;
extern int      screen_lines;

/* PROTO */
void
parse_input(void)
{
	int             offset;

	if (strncasecmp(inputbuf, "q!", 2) == 0) {
		restore_tty();
		printf("\n");
		exit(-1);
	} else if (inputbuf[0] == 'm') {
		char           *msg, *temp, *temp2, *sn;
		char           *fullmsg;

		if (inputbuf[1] == ' ')
			temp2 = inputbuf + 2;
		else
			temp2 = inputbuf + 1;

		temp = strchr(temp2, ' ');

		if (temp == NULL) {
			printf("\nNo message to send.\n");
			return;
		}
		if (strlen(temp + 1) == 0) {
			printf("\nNo message to send.\n");
			return;
		}
		if (conn->netspeak_filter)
			msg = undo_netspeak(temp + 1);
		else
			msg = temp + 1;

		sn = malloc(temp - temp2 + 1);
		sn[temp - temp2] = 0;
		strncpy(sn, temp2, temp - temp2);
		fullmsg = malloc(strlen(msg) + strlen(SEND_FORMAT_BEGIN) + strlen(SEND_FORMAT_END) + 1);
		sprintf(fullmsg, "%s%s%s", SEND_FORMAT_BEGIN, msg, SEND_FORMAT_END);
		imcomm_im_send_message(conn->conn, sn, fullmsg, 0);
		free(fullmsg);
		eraseline();
#ifdef TIMESTAMPS
		addts();
		putchar(' ');
		offset = 13;
#else
		offset = 2;
#endif
		offset += strlen(sn) + 2;
#ifdef COLOR
		set_color(COLOR_OUTGOING_IM);
#endif
		printf("->%s", sn);
#ifdef COLOR
		set_color(0);
#endif
		printf(": ");
		wordwrap_print(msg, offset);

		if (conn->lastsn != NULL)
			free(conn->lastsn);
		conn->lastsn = strdup(sn);
		log_event(EVENT_IMSEND, sn, msg);
		free(sn);

		if (conn->netspeak_filter)
			free(msg);
		return;

	} else if (inputbuf[0] == 'w') {
		printf("\n** ");
		addts();
		printf(" %d buddies online:\n", conn->buddiesonline);

		if (inputbuf[1] == 'f')
			display_buddylist();
		else
			display_buddylist_sorted();

		return;
	} else if (inputbuf[0] == 'h' || inputbuf[0] == '?') {
		printf("\nbsflite commands:\n");
		printf("   h            : what you see right now\n");
		printf("   w            : show buddy list\n");
		printf("   ws           : show buddy list, sorted (default)\n");
		printf("   wf           : show buddy list, unsorted\n");
		printf("   l<sn>        : show last 10 lines from <sn>\n");
		printf("   ll           : show last 10 lines from last buddy\n");
		printf("   m<sn> <msg>  : send msg to sn\n");
		printf("   r<msg>       : reply to the last msg received/sent\n");
		printf("   a<sn>        : add buddy\n");
		printf("   d<sn>        : delete buddy\n");
		printf("   g<msg>       : set away message\n");
		printf("   g            : unset away message\n");
		printf("   G            : display pre-defined away messages\n");
		printf("   G<num>       : set pre-defined away message\n");
		printf("   i<sn>        : get profile and away message\n");
		printf("   A<sn>        : get away message\n");
		printf("   P<sn>        : get profile\n");
		printf("   b            : show away messages for all buddies\n");
		printf("   q!           : quit");
	} else if (inputbuf[0] == 'l') {
		if (inputbuf[1] == 'l' && inputbuf[2] == 0) {
			if (conn->lastsn != NULL) {
				show_log(20, conn->lastsn);
				return;
			}
		} else {
			show_log(20, inputbuf + 1);
			return;
		}
	} else if (inputbuf[0] == 'a') {
		char           *tmp;
		if (inputbuf[1] == ' ')
			tmp = inputbuf + 2;
		else
			tmp = inputbuf + 1;
		imcomm_im_add_buddy(conn->conn, tmp);
		printf("\n** Added buddy %s.\n", tmp);
		return;
	} else if (inputbuf[0] == 'd') {
		char           *tmp;
		if (inputbuf[1] == ' ')
			tmp = inputbuf + 2;
		else
			tmp = inputbuf + 1;

		imcomm_im_remove_buddy(conn->conn, tmp);
		printf("\n** Removed buddy %s.\n", tmp);
		remove_from_list(tmp);
		return;
	} else if (inputbuf[0] == 'g') {
		char           *tmp;
		if (conn->isaway) {
			conn->isaway = 0;
			free(conn->awaymsg);
			imcomm_set_unaway(conn->conn);
			printf("\n** You are no longer away.\n");
			return;
		} else {
			if (inputbuf[1] == ' ')
				tmp = inputbuf + 2;
			else
				tmp = inputbuf + 1;
			printf("\n** You are now away: %s\n", tmp);
			conn->isaway = 1;
			imcomm_set_away(conn->conn, tmp);
			conn->awaymsg = strdup(tmp);
			return;
		}
	} else if (inputbuf[0] == 'i') {
		char           *tmp;
		if (inputbuf[1] == ' ')
			tmp = inputbuf + 2;
		else
			tmp = inputbuf + 1;

		imcomm_request_awayprofile(conn->conn, tmp);
	} else if (inputbuf[0] == 'A') {
		char           *tmp;
		if (inputbuf[1] == ' ')
			tmp = inputbuf + 2;
		else
			tmp = inputbuf + 1;

		imcomm_request_awaymsg(conn->conn, tmp);
	} else if (inputbuf[0] == 'P') {
		char           *tmp;
		if (inputbuf[1] == ' ')
			tmp = inputbuf + 2;
		else
			tmp = inputbuf + 1;

		imcomm_request_profile(conn->conn, tmp);
	} else if (inputbuf[0] == 'I') {
		int             time;
		char           *tmp;

		if (inputbuf[1] == ' ')
			tmp = inputbuf + 2;
		else
			tmp = inputbuf + 1;

		time = atoi(tmp);

		set_idle_time(conn->conn, time);
	} else if (inputbuf[0] == 'b') {
		eraseline();
		printf("** Requesting away messages");
		fflush(stdout);
		showAwayMessages();
	} else if (inputbuf[0] == 'G') {
		int             msgnum = 0, count;
		struct AwayMessages *tv;

		if (conn->awaymsgs == NULL) {
			printf("\n** No away messages defined.\n");
			return;
		}
		if (inputbuf[1] == 0) {
			printf("\n** Defined messages:");
			for (tv = conn->awaymsgs, count = 0; tv != NULL; tv = tv->next, count++)
				printf("\n** [%02d] \"%s\"", count, tv->message);
		} else {
			msgnum = atoi(inputbuf + 1);
			for (tv = conn->awaymsgs, count = 0; tv != NULL; tv = tv->next, count++) {
				if (count == msgnum) {
					printf("\n** You are now away: %s", tv->message);
					conn->isaway = 1;
					imcomm_set_away(conn->conn, tv->message);
					conn->awaymsg = strdup(tv->message);
					break;
				}
			}
		}
	}
	printf("\n");
}
